#region legal please read
/*
 * Copyright iFinity Software 2012 
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, 
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom 
 * the Software is furnished to do so, subject to the following conditions:

 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE 
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR 
 * IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * */
#endregion

using System.Collections.Generic;
using System.Xml;
using DotNetNuke.Entities.Portals;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Modules.Dashboard.Data;
using DotNetNuke.Modules.Dashboard.Components;
namespace DotNetNuke.Modules.SocialDashboard.Components
{
    public class SocialDashboardController : IDashboardData
    {

        #region public method

        /// <summary>
        /// Gets all the DotNetNuke.Modules.SocialDashboardInfo objects for items matching the this moduleId
        /// </summary>
        /// <param name="moduleId"></param>
        /// <returns></returns>
        public List<SocialDashboardInfo> GetSocialDashboardData(string cultureCode)
        {
            return CBO.FillCollection<SocialDashboardInfo>(DataProvider.Instance().GetSocialDashboardData(cultureCode));
        }


        #endregion



        #region IDashboardData Members

        void IDashboardData.ExportData(XmlWriter writer)
        {
            //export data as Xml
            //Write start of Portals 
            writer.WriteStartElement("portalsSocialData");

            //Iterate through Portals 
            string language = "";
            PortalSettings ps = DotNetNuke.Entities.Portals.PortalController.GetCurrentPortalSettings();
            if (ps != null)
            {
                language = ps.CultureCode;
            }
            if (language == null)
                language = "en-US";//fallback
            
            foreach (SocialDashboardInfo socialInfo in GetSocialDashboardData(language))
            {
                socialInfo.WriteXml(writer);
            }

            //Write end of Portals 
            writer.WriteEndElement();
        }

        #endregion
    }
}
